from tkinter import *
def draw(canvas, x0, y0, x1, y1):
	
	# define variables 
	r2 = (y1 - y0)/2
	cy2 = y1 - r2
	cx2 = x1 - r2
	r1 = ((x1-x0)-(y1-y0))/2 
	cy1 = cy2
	cx1 = x0 + r1
	
	canvas.create_oval(cx1-r1, cy1-r1, cx1+r1, cy1+r1) # these functions are important
	# comfortable with them 
	canvas.create_oval(cx2-r2, cy2-r2, cx2+r2, cy2+r2)
	canvas.create_line(x0, cy1, x1, cy1)
	canvas.create_text(cx1, cy1-5, text="A")
	canvas.create_text(cx2, cy2-5, text="B")


def runDrawing(width=300, height=300):
    root = Tk()
    canvas = Canvas(root, width=width, height=height)
    canvas.pack()
    draw(canvas, 100, 100, 700, 500)
    root.mainloop()
    print("bye!")

runDrawing(800, 800)