## Lecture Today: Graphics

## Goals for today: 
	# Tkinter => module that we use for drawing
	# be able to draw simple shapes in Tkinter (rectangle, circle, etc.) => what will be covered on quiz
	# be comfortable with drawing grid like shapes (boards, etc.) => what will be on HW + midterm
	# very important for general CS applications going forward
		# developing applications (UI)
		# your term project!

	# Big example today:
		# drawClock (see notes for implementation!)
			# trig

## HW6, will be released later today (Sun at 5pm)
	## focus on graphics
		# drawSudoku
		# graphics problem
		# 2D lists problem
	## Didn't want too many HWs out at once

from tkinter import * #include import statement for graphics

def draw(canvas, width, height):
	## drawing helpers will be of this form:
    	# canvas.create_<shape>(topX, topY, bottomX, bottomY, extra arguments like color, etc.)
    
    # Important ones: rectangle, oval, line, text, polygon
    	# polygon: takes in all the points (point1X, point1Y, point2X, point2Y)...
    
    canvas.create_rectangle(10,10,150,150, fill="yellow") # fill gives you the color
    # (topX, topY, bottomX, bottomY)
    # (0, 0) is the top left corner
    # as y increases => going down

    # common pattern
    r = 50 # pixels
    cx = 250
    cy = 250
    canvas.create_oval(cx-r, cy-r, cx+r, cy+r)
    canvas.create_oval(200, 200, 300, 300, fill="red")
    # (Topx, topy, bottomx, bottomy)
    canvas.create_line(150, 150, 10, 10, width=3)
    
    # center point (centerX, centerY) => center the text around that point
    canvas.create_text(200, 100, text="WOW!!!!!")
    canvas.create_polygon(0, 0, 50, 0, 50, 50, 0, 50)

# don't have to duplicate this on exam, but understand how it works
def runDrawing(width=300, height=300): # 300 pixels x 300 pixels
# width and height of the window, pass any additional arguments you may need
    root = Tk() # main window
    canvas = Canvas(root, width=width, height=height) # where we draw our graphics
    canvas.pack() # attach canvas to window
    draw(canvas, width, height) # call drawing functions
    root.mainloop() # display drawing - console is frozen for the time being
    print("bye!")

runDrawing(600, 400)


# important: up is down
# (0,0) represents the top of the canvas, and we work our way down


# Strategy graphics:
	# what variables do you need
	# try to figure out important locations of variables
		# position of the hour hand/minute hand
		# center of the clock
		# location of the numbers


## Quiz Tomorrow:
	# Quick point: destructive & non-destructive and how they relate to lists
	# review session today at 7:30 pm
	# practice quizzes: look at past semesters
	# general outline
